// ANCHOR: here
use std::{
    sync::{mpsc, Arc, Mutex},
    thread,
};
// --fragment pominięty--

// ANCHOR_END: here
pub struct ThreadPool {
    workers: Vec<Worker>,
    sender: mpsc::Sender<Job>,
}

struct Job;

// ANCHOR: here
impl ThreadPool {
    // --fragment pominięty--
    // ANCHOR_END: here
    /// Tworzy nową instancję ThreadPool.
    ///
    /// size to liczba watków w puli.
    ///
    /// # Panikuje
    ///
    /// Funkcja `new` wywoła panikę, jeśli size będzie równy 0.
    // ANCHOR: here
    pub fn new(size: usize) -> ThreadPool {
        assert!(size > 0);

        let (sender, receiver) = mpsc::channel();

        let receiver = Arc::new(Mutex::new(receiver));

        let mut workers = Vec::with_capacity(size);

        for id in 0..size {
            workers.push(Worker::new(id, Arc::clone(&receiver)));
        }

        ThreadPool { workers, sender }
    }

    // --fragment pominięty--
    // ANCHOR_END: here

    pub fn execute<F>(&self, f: F)
    where
        F: FnOnce() + Send + 'static,
    {
    }
    // ANCHOR: here
}

// --fragment pominięty--

// ANCHOR_END: here
struct Worker {
    id: usize,
    thread: thread::JoinHandle<()>,
}

// ANCHOR: here
impl Worker {
    fn new(id: usize, receiver: Arc<Mutex<mpsc::Receiver<Job>>>) -> Worker {
        // --fragment pominięty--
        // ANCHOR_END: here
        let thread = thread::spawn(|| {
            receiver;
        });

        Worker { id, thread }
        // ANCHOR: here
    }
}
// ANCHOR_END: here
